<?php
/*****************************************************************************
 * ID   : $Id: image_tb.php,v 1.2 2007/08/18 08:14:57 secondarykey Exp $
 * Name : 画像操作
 * Specifications : イメージテーブルの他、画像に関する操作を行うクラス
 ****************************************************************************/
  class image_tb extends tables { 
  	
 	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "image_tb"; 
	var $myColumnName       = "id,name,alt,ext";
	var $myInsertColumnName = "name,alt,ext";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "id";

	/**
	 * メンバ変数
	 **/	
 	var $myID;	
	var $myName;	
	var $myAlt;	
	var $myExt;	
  
	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return "'" . $this->myName . "'," . 
		        "'" . $this->myAlt  . "'," .
		        "'" . $this->myExt  . "'";
	}	
	
	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " name='" . $this->myName . "'," .
		        " alt='"  . $this->myAlt  . "'";
	}

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	image_tb();
		$obj->setID($aRow->id);
		$obj->setName($aRow->name);
		$obj->setAlt($aRow->alt);
		$obj->setExt($aRow->ext);
		return $obj;
	}
	
	/**
	 * 保存するファイルパス
	 */
	function getImagePath() {
		return SiteObject::get("IMAGE_PATH");
	}

	/**
	 * その画像のタグ
	 */	
	function getImageTag() {
		return $this->createImageTag('.');
	}
	
	/**
	 * その画像のタグ
	 */	
	function getImageSrc() {
		return $this->createImageSrc('.');
	}

	/**
	 * 管理時の画像タグ
	 */	
	function getManageImageTag() {
		return $this->createImageTag('../..');
	}

	/**
	 * ページ画像タグ
	 */	
	function getPageImageTag($aID,$aCnt) {
		return image_tb::createPageImageTag('.',$aID,$aCnt);
	}
	
	/**
	 * ページ画像名
	 */	
	function getPageImageSrc($aID,$aCnt) {
		return image_tb::createPageImageSrc('.',$aID,$aCnt);
	}

	/**
	 * 管理時のページ画像タグ
	 */	
	function getManagePageImageTag($aID,$aCnt) {
		return image_tb::createPageImageTag('../..',$aID,$aCnt);
	}
	
	/**
	 * 属性画像タグ
	 */	
	function getAttributeImageTag($aID,$aVariable) {
		return image_tb::createAttributeImageTag('.',$aID,$aVariable);
	}

	/**
	 * 属性画像名
	 */	
	function getAttributeImageSrc($aID,$aVariable) {
		//名称を作成
		$name = image_tb::getAttributeImageName($aID,$aVariable);
	
		$file_path = image_tb::getImagePath() . $name;
		$image_src = "";

		//ファイルが存在する場合
		if ( file_exists($file_path) ) {
			//タグを作成
			$image_src = './images/'. $name;
		}
        return $image_src;
	}

	/**
	/**
	 * 管理時の属性画像タグ
	 */	
	function getManageAttributeImageTag($aID,$aVariable) {
		return image_tb::createAttributeImageTag('../..',$aID,$aVariable);
	}
	
	/**
	 * imgタグを作成
	 */
	function createImageTag($aPath) {
		$image_tag = '<img src="' . $aPath . '/images/'. $this->myID .
                 '" alt="' . $this->myAlt . '" title="' . $this->myAlt . '">';
        return $image_tag;
	}

	/**
	 * imgタグを作成
	 */
	function createImageSrc($aPath) {
		$image_src = $aPath . '/images/'. $this->myID;
        return $image_src;
	}	
	
	/**
	 * Page画像タグ作成
	 */
	function createPageImageTag($aPath,$aID,$aCnt) {
		//名称を作成
		$name = image_tb::getPageImageName($aID,$aCnt);
		$file_path = image_tb::getImagePath() . $name;
		
		$image_tag = "";

		//ファイルが存在する場合
		if ( file_exists($file_path) ) {
			$src = image_tb::createPageImageSrc($aPath,$aID,$aCnt);
			//タグを作成
			$image_tag = '<img src="' . $src . '">';
		}
        return $image_tag;
	}
	
	/**
	 * Page画像パス
	 */
	function createPageImageSrc($aPath,$aID,$aCnt) {
		//名称を作成
		$name = image_tb::getPageImageName($aID,$aCnt);
		return $aPath . '/images/'. $name;
	}
	
	/**
	 * 属性画像タグ作成
	 */
	function createAttributeImageTag($aPath,$aID,$aVariable) {
		//名称を作成
		$name = image_tb::getAttributeImageName($aID,$aVariable);
	
		$file_path = image_tb::getImagePath() . $name;
		$image_tag = "";

		//ファイルが存在する場合
		if ( file_exists($file_path) ) {
			//タグを作成
			$image_tag = '<img src="' . $aPath . '/images/'. $name . '">';
		}
        return $image_tag;
	}

	/**
	 * ファイルを削除
	 */
	function deleteFile($aID) {
		//ファイル名を取得
		$id_path = image_tb::getImagePath() . $aID;
		if ( file_exists($id_path) ) {
			$fh=unlink($id_path);
		}
		return;
	}
	
	/**
	 * ページ画像ファイルを削除
	 */
	function deletePageImageFile($aID,$aCnt) {
		//ファイル名を取得
		$id_path = image_tb::getImagePath() . image_tb::getPageImageName($aID,$aCnt);
		//ファイルが存在する場合
		if ( file_exists($id_path) ) {
			//削除を行う
			$fh=unlink($id_path);
		}
		return;
	}

	/**
	 * 属性画像ファイルを削除
	 */
	function deleteAttributeImageFile($aID,$aVariable) {
		//ファイル名を取得
		$id_path = image_tb::getImagePath() . image_tb::getAttributeImageName($aID,$aVariable);
		//ファイルが存在する場合
		if ( file_exists($id_path) ) {
			//削除を行う
			$fh=unlink($id_path);
		}
		return;
	}

	/**
	 * ページ画像ファイル名称作成
	 */	
	function getPageImageName($aID,$aCnt) {
		//%s:ページID,%s:通番	
		$fileName = sprintf('IMAGE_PAGE_%s_%s',$aID,$aCnt);
		return $fileName;
	}
	
	/**
	 * 属性画像ファイル名称作成
	 */	
	function getAttributeImageName($aID,$aVariable) {
		//%s:ページID,%s:通番	
		$fileName = sprintf('IMAGE_ATTRIBUTE_%s_%s',$aID,$aVariable);
		return $fileName;
	}
	
	/**
	 * アップロードする画像を表示
	 */	
	function createPageImageTable($aID) {
		
		$rtnTable = "<table>";
		$rtnTable = $rtnTable . '<input type="hidden" name="exec" value=""/>';
		//画像アップロード用のフォームを作成
		for ( $cnt = 1; $cnt <= 5; ++$cnt )	{
			$rtnTable = $rtnTable . "<tr>";
			$rtnTable = $rtnTable . '<td>画像' . $cnt . '</td>';
			$rtnTable = $rtnTable . '<td>' . 
                                    '<input type="file" name="image' . $cnt .'">' .
			                        '</td>' ;
			$rtnTable = $rtnTable . '<td> ' . '</td>';
			$rtnTable = $rtnTable . '</tr>';
		}
		$rtnTable = $rtnTable . "</table><br><br>";
	
		//現在の画像を表示		
		$rtnTable = $rtnTable . "現在の画像";
		$rtnTable = $rtnTable . "<table>";
		for ( $cnt = 1; $cnt <= 5; ++$cnt )	{
			$rtnTable = $rtnTable . "<tr>";
			$rtnTable = $rtnTable . '<td>画像' . $cnt . '</td>';
			$rtnTable = $rtnTable . '<td>' . 
									image_tb::getManagePageImageTag($aID,$cnt) .
			                        '</td>' ;
			$rtnTable = $rtnTable . '<td><input type="image" src="../images/btn_sakujo.gif" onclick="return btn_delete(this.form,\'' . $cnt . '_delete\');"></td>';
			$rtnTable = $rtnTable . '</tr>';
		}
		$rtnTable = $rtnTable . "</table>";

		return $rtnTable;
	}

	/**
	 * 属性の画像テーブルを作成
	 */	
	function createAttributeImageTable($aID,$aVariable) {
		$rtnTable = "<table>";
		$rtnTable = $rtnTable . '<input type="hidden" name="exec" value=""/>';
		//画像アップロード用のフォームを作成
		$rtnTable = $rtnTable . "<tr>";
		$rtnTable = $rtnTable . '<td>画像</td>';
		$rtnTable = $rtnTable . '<td>' . 
								'<input type="file" name="attributeImage">' .
		                        '</td>' ;
		$rtnTable = $rtnTable . '</tr>';
		$rtnTable = $rtnTable . "</table>";
		//現在の画像を表示		
		$rtnTable = $rtnTable . "<br><br>現在の画像" . 
		       '<input type="image" src="../images/btn_sakujo.gif" onclick="return btn_delete(this.form,\'' . $aVariable . '_delete\');">' .
		       "<br>" . image_tb::getManageAttributeImageTag($aID,$aVariable);
		return $rtnTable;
	}
	
  	function getID() {
		return $this->myID;
	}

	function getName() {
		return $this->myName;
	}
	
	function getAlt() {
		return $this->myAlt;
	}
	
	function getExt() {
		return $this->myExt;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}
	
	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setAlt($aAlt) {
		$this->myAlt = $aAlt;
	}
	
	function setExt($aExt) {
		$this->myExt = $aExt;
	}
  } 
?>
