<?php
/*****************************************************************************
 * ID   : $Id: page_tb.php,v 1.2 2007/08/18 08:19:17 secondarykey Exp $
 * Name : ページテーブル操作
 * Specifications :　ページテーブルの操作を行う
 ****************************************************************************/
  class page_tb extends tables { 

  	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "page_tb"; 
	var $myColumnName       = "id,parent_id,template_site_id,template_page_id,name,detail,alias,priority,createdate,editdate";
	var $myInsertColumnName = "parent_id,template_site_id,template_page_id,name,detail,alias,priority,createdate,editdate";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "priority,id desc";

	/**
	 * メンバ変数
	 **/	
 	var $myID;	
	var $myParent_ID;	
	var $myTemplate_Site_ID;	
	var $myTemplate_Page_ID;	
	var $myName;	
	var $myDetail;
	var $myAlias;	
	var $myPriority;	
	var $myCreateDate;	
	var $myEditDate;	
  
	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return       $this->myParent_ID        . "," . 
		              $this->myTemplate_Site_ID . "," . 
		              $this->myTemplate_Page_ID . "," . 
		        "'" . $this->myName             . "'," . 
		        "'" . $this->myDetail           . "'," . 
		        "'" . $this->myAlias            . "'," . 
		              $this->myPriority         . "," . 
		        "'" . $this->myCreateDate       . "'," . 
		        "'" . $this->myEditDate         . "'";
	}	
	
	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " parent_id = "        . $this->myParent_ID        . "," . 
                " template_site_id = " . $this->myTemplate_Site_ID . "," .
                " template_page_id = " . $this->myTemplate_Page_ID . "," .
                " name = '"            . $this->myName             . "'," .
                " detail = '"          . $this->myDetail           . "'," .
                " alias = '"           . $this->myAlias            . "'," .
                " priority = "         . $this->myPriority         . "," .
                " editdate = '"        . $this->myEditDate         . "'";
	}	

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	page_tb();
		$obj->setID($aRow->id);
		$obj->setParent_ID($aRow->parent_id);
		$obj->setTemplate_Site_ID($aRow->template_site_id);
		$obj->setTemplate_Page_ID($aRow->template_page_id);
		$obj->setName($aRow->name);
		$obj->setDetail($aRow->detail);
		$obj->setAlias($aRow->alias);
		$obj->setPriority($aRow->priority);
		$obj->setCreateDate($aRow->createdate);
		$obj->setEditDate($aRow->editdate);
		return $obj;
	}

	/**
	 * ページの制限リストを取得
	 */
	function getPageList($aID,$aPageNum) {	
		//ページを検索	
		return $this->selectByPage($aPageNum," where parent_id = " . $aID);
	}

	/**
	 * ページ一覧作成用のツリーを作成
	 */	
 	function createTreeView($aID,$aPageName="page_editing.php") {

 		$page_tb = new page_tb;
 		//ページを全件検索する	
 		$page_array = $page_tb->select();
 		$pkey_array = array();
 		$hide_array = array();
 		$treeView = '';

		//前頁繰り返す
 		foreach ($page_array as $page) {
 			$id = $page->getID();
 			$pid = $page->getParent_ID();
 			if ( $id == PAGE_ROOTID ) {
 				$pid = 0;	
 			}
 			$wkarray = $pkey_array[$pid];
 			//配列がまだ存在しない場合
 			if ( $wkarray == null ) {
				$wkarray = array();
 				array_push($wkarray,$page);
 				//内部配列にページを追加
				$pkey_array[$pid] = $wkarray;
 			} else {
 				array_push($wkarray,$page);
				$pkey_array[$pid] = $wkarray;
 			}
 		}
 		//トップページを取得する
		$pageData = $pkey_array[0][0];
		$c_tree = page_tb::createStructural($pageData->getID(),0,$aPageName,$hide_array,$pkey_array);
 		//子が作れない状況の場合
		if ( $c_tree == '' ) {
			//ページ用のラインを取得
			$line = $pageData->getPageLine(0,$hide_array);
			$treeView = $line;
		} else {
			//ディレクトリラインを取得
			$line = $pageData->getDirectoryLine(0,$aPageName,$hide_array);
			//親のラインを閉じる	
			$treeView = $line . $c_tree . '</div>';
		}
 		$treeView = $treeView . '<script language="JavaScript1.2">';
 		//取得できたID数回繰り返す	
 		foreach ( $hide_array as $id ) {
 			if ( $aID != $id ) {
				$treeView = $treeView . "changeLAYER('elm" . $id . "');";
 			}
 		}
 		$treeView = $treeView . '</script>';

		return $treeView;
 	}
  	/**
	 * ツリービュー作成の再帰関数
	 */ 
 	function createStructural($aID,$aIdx,$aPageName,&$aHideArray,&$aPageArray) {

		$treeView = ''; 
		//親に持つページを設定
 		$page_array = $aPageArray[$aID];
 		//下階層が存在しない場合
 		if ( $page_array != null ) {
 			$idx = $aIdx + 1;
 			//ページ数回繰り返す	
 			foreach ( $page_array as $page ) {
 				//データ	
 				$id = $page->getID();
 				//親の階層を終了	
 				$view = page_tb::createStructural($id,$idx,$aPageName,$aHideArray,$aPageArray);
 				$line = '';
				//子が作れない状況の場合
				if ( $view == '' ) {
					//ページ用のラインを取得
					$line = $page->getPageLine($idx,$aPageName);
				} else {
					//ディレクトリラインを取得
					$wkline = $page->getDirectoryLine($idx,$aPageName,$aHideArray);
					//親のラインを閉じる	
 					$line = $wkline . $view . '</div>';
				}
				//ラインに追加する
 				$treeView = $treeView . $line;
 			}
 		
 		}
		return $treeView;
 	}
 	/**
 	 * ディレクトリの行を作成
 	 */	
 	function getDirectoryLine($aIdx,$aPageName,&$aHideArray) {
 		
 		$id = $this->getID();
 		//インデントイメージを取得
 		$rtn = page_tb::getIndentImage($aIdx);
 		$rtn = $rtn . '<img src="../images/dir.gif" valign="middle" ' . 
               'onClick="changeLAYER(\'elm' . $id . '\')" ' .
               'alt="' . $id . '" title="' . $id . '"/>';
        //リンクを作成 
        $rtn = $rtn . $this->getLinkLine($aPageName);
		//エレメントを開く部分
 		$rtn = $rtn . '<div id="elm' . $id . '">';
 		
 		$aHideArray[] = $id;
 		
 		return $rtn;
 	}
 
 	/**
 	 * ページの行を取得
 	 */	
 	function getPageLine($aIdx,$aPageName) {
 		$id = $this->getID();
 		$rtn = page_tb::getIndentImage($aIdx);
 		$rtn = $rtn . '<img src="../images/file.gif" valign="middle" ' . 
               'alt="' . $id . '" title="' . $id . '"/>';
        //リンクを作成 
        $rtn = $rtn . $this->getLinkLine($aPageName);
 		return $rtn;
 	}

	/**
	 * ページのリンクを作成
	 */
 	function getLinkLine($aPageName) {
 		$rtn = '<a href="' . $aPageName . '?id=' . $this->getID() .  '"' .
 		       ' target="view" valign="middle">' . $this->getName() . "</a><br>";
 		return $rtn;
 	}

	/**
	 * インデント量でツリーのスペース画像を設定
	 */
 	function getIndentImage($aIdx)	{
 		//インデックスからインデント量を計算
 		$width = $aIdx * 16;
 		//スペースイメージを作成
 		$rtn = '<img src="../images/space.gif" width="' . $width . '" height="18">';
        return $rtn;
 	} 

	/**
	 * ツリービュー作成の再帰関数
	 */ 
 	function createChildrenTreeView($aID,$aIdx,$aPageName,&$aHideArray) {

		$treeView = ''; 
		//親に持つページを設定
 		$page_array = page_tb::selectParentID($aID,20);
 		//下階層が存在しない場合
 		if ( $page_array != null ) {
 			
 			$idx = $aIdx + 1;
 			//ページ数回繰り返す	
 			foreach ( $page_array as $page ) {
 				//データ	
 				$id = $page->GetID();	
 				//親の階層を終了	
 				$view = page_tb::createChildrenTreeView($id,$idx,$aPageName,$aHideArray);
 				$line = '';
				//子が作れない状況の場合
				if ( $view == '' ) {
					//ページ用のラインを取得
					$line = $page->getPageLine($idx,$aPageName);
				} else {
					//ディレクトリラインを取得
					$wkline = $page->getDirectoryLine($idx,$aPageName,$aHideArray);
					//親のラインを閉じる	
 					$line = $wkline . $view . '</div>';
				}
				//ラインに追加する
 				$treeView = $treeView . $line;
 			}
 		
 		}
		return $treeView;
 	}

	/**
	 * 指定した親IDでページを取得
	 */
 	function selectParentID($aParentID,$aLimit=0) {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from page_tb" . 
               " where parent_id = " . $aParentID . ' order by priority desc';
        if ( $aLimit != 0 ) {
        	$sql = $sql . " limit 0,".$aLimit;
        }
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();

		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = page_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}
 
 	/**
 	 * ページ順序用のテーブルを作成
 	 */	
 	function getPageOrderTable($aParentID) {
 		//親の下層を検索
 		$pageArray = page_tb::selectParentID($aParentID);
 		$rtn  = '<table border="1" width="100%">';
 		$rtn = $rtn . '<tr>';
 		$rtn = $rtn . '<td width="50">↑</td>';
 		$rtn = $rtn . '<td width="50">ID</td>';
 		$rtn = $rtn . '<td>名称</td>';
 		$rtn = $rtn . '<td width="50">↓</td>';
 		$rtn = $rtn . '</tr>';
 		$cnt  = 1;
 		$leng = count($pageArray);
 		
 		//ページ数回繰り返す
 		foreach ( $pageArray as $page ) {
 			
 			$id = $page->getID();
 			$name = $page->getName();
 			$priority = $page->getPriority();

 			$rtn = $rtn . '<form action="page_order_exec.php" method="post">';
 			$rtn = $rtn . '<tr>';
 	
 			$rtn = $rtn . '<td>';
 			//最初でない場合
 			if ( $cnt != 1) {
				$rtn = $rtn . '<input type="submit" name="exec" value="↑">';
 			} else {
				$rtn = $rtn . '-';
 			}
 			$rtn = $rtn . '</td>';
 			
 			$rtn = $rtn . '<td>' . $id . '</td>';
 			$rtn = $rtn . '<td>' . $name . '</td>';
 			
 			$rtn = $rtn . '<td> ';
 			//最初でない場合
 			if ( $cnt != $leng) {
				$rtn = $rtn . '<input type="submit" name="exec" value="↓">';
 			} else {
				$rtn = $rtn . '-';
 			}
 			$rtn = $rtn . '</td>';
 			
 			$rtn = $rtn . '</tr>';
 			$rtn = $rtn . '<input type="hidden" name="parent_id" value="' . $aParentID . '">';
 			$rtn = $rtn . '<input type="hidden" name="priority" value="' . $priority . '">';
 			$rtn = $rtn . '</form>';
 
 			$cnt = $cnt + 1;
 		}
 		$rtn = $rtn . '</table>';
 
 		return $rtn;
 	}
 
 	/**
 	 * 優先順位からの検索
 	 */	
 	function selectPagePriority($aParentID,$aPriority) {
 		
 		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from page_tb" . 
               " where parent_id = " . $aParentID . ' and priority=' . $aPriority;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();

		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = page_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}
 	
   	/**
 	 * サイトテンプレートからの検索
 	 */	
 	function selectByTemplateSiteID($aTemplateSiteID) {
 		
 		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from page_tb" . 
               " where template_site_id = " . $aTemplateSiteID;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = page_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}
 	
   	/**
 	 * ページテンプレートからの検索
 	 */	
 	function selectByTemplatePageID($aTemplatePageID) {
 		
 		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from page_tb" . 
               " where template_page_id = " . $aTemplatePageID;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = page_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}
	/**
	 * 指定したIDでページを取得
	 */
 	function selectPageID($aPageIDArray) {
 		if ( $aPageIDArray == null ) {
 			return null;
 		}
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from page_tb" . 
               " where ";
        $where = "";
        foreach ( $aPageIDArray as $id ) {
        	if ( $where != "" ) $where = $where . " or ";
        	$where = $where . "id = " . $id;
        }
        $sql = $sql . $where;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();

		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = page_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}
 	
 	
  
  	function getID() {
		return $this->myID;
	}

	function getParent_ID() {
		return $this->myParent_ID;
	}
	
	function getTemplate_Site_ID() {
		return $this->myTemplate_Site_ID;
	}
	
	function getTemplate_Page_ID() {
		return $this->myTemplate_Page_ID;
	}
	
	function getName() {
		return $this->myName;
	}
	
	function getDetail() {
		return $this->myDetail;
	}
	
	function getAlias() {
		return $this->myAlias;
	}
	
	function getPriority() {
		return $this->myPriority;
	}
	
	function getCreateDate() {
		return $this->myCreateDate;
	}
	
	function getEditDate() {
		return $this->myEditDate;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}
	
	function setParent_ID($aParent_ID) {
		$this->myParent_ID = $aParent_ID;
	}
	
	function setTemplate_Site_ID($aTemplate_Site_ID) {
		$this->myTemplate_Site_ID = $aTemplate_Site_ID;
	}
	
	function setTemplate_Page_ID($aTemplate_Page_ID) {
		$this->myTemplate_Page_ID = $aTemplate_Page_ID;
	}
	
	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setDetail($aDetail) {
		$this->myDetail = $aDetail;
	}
	
	function setAlias($aAlias) {
		$this->myAlias = $aAlias;
	}
	
	function setPriority($aPriority) {
		$this->myPriority = $aPriority;
	}
	
	function setCreateDate($aCreateDate) {
		$this->myCreateDate = $aCreateDate;
	}
	
	function setEditDate($aEditDate) {
		$this->myEditDate = $aEditDate;
	}
  } 
?>
